/* Event Cats Javascript functions LucMorizur June - ... 2009 */

var ec_avoid_infinite_loop      = true;
var ec_err                      = '';
var ec_selected_action          = '';
var ec_selected_img             = '';
var ec_new_code_text            = '';
var ec_new_user_text            = '';
var ec_new_psd_text             = '';
var ec_old_new_psd_text         = '';
var ec_test_reg                 = '';
var ec_selected_old_user        = '-1';
var ec_selected_AP              = '-1';
var ec_selected_cat             = '-1';
var ec_selected_user            = 'ec_sel_user_old';
var ec_JS_message               = new Array();
var ec_auto_code_digits_default =
 document.getElementById('ec_in_up_auto_code_length_id').value;
var ec_auto_code_digits_nb      = ec_auto_code_digits_default;

function ec_mark_user(ec_id) {
  ec_selected_user = ec_id;
  document.getElementById(ec_selected_user).checked = 'checked';
  switch (ec_selected_user) {
    /* case 'ec_sel_user_none': // None
      ec_selected_action =
       (ec_ap_ok && (ec_selected_action != 'ec_input_action_home')) ?
       'ec_input_action_add_p' : 'ec_input_action_home';
      document.getElementById('ec_in_up_usr_txt_id').value = '';
      document.getElementById('ec_in_up_psd_txt_id').value = '';
      document.getElementById('ec_in_up_usr_list_id').value = '-1';
    break; */
    case 'ec_sel_user_new': // New user
      document.getElementById('ec_in_up_usr_txt_id').value =
       ec_new_user_text;
      document.getElementById('ec_in_up_psd_txt_id').value =
       ec_new_psd_text;
      document.getElementById('ec_in_up_usr_list_id').value = '-1';
    break;
    case 'ec_sel_user_old': // "Old" user
      document.getElementById('ec_in_up_usr_txt_id').value = '';
      document.getElementById('ec_in_up_psd_txt_id').value = '';
      document.getElementById('ec_in_up_usr_list_id').value =
       ec_selected_old_user;
    break;
  }
  ec_check_pwd_text();
  if (ec_avoid_infinite_loop) {
    ec_avoid_infinite_loop = false;
    ec_mark_action(ec_selected_action);
    ec_avoid_infinite_loop = true;
  }
}

function ec_mark_action(ec_id) {
  ec_selected_action = ec_id;
  if (ec_selected_action != '') {
    document.getElementById(ec_selected_action).checked = 'checked';
    switch (ec_selected_action) {
      case 'ec_input_action_add_p': // Additional Page
        document.getElementById('ec_in_up_aps_id').value = ec_selected_AP;
        document.getElementById('ec_in_up_cats_id').value = '-1';
        document.getElementById('ec_in_up_imgs_id').value = '';
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
      case 'ec_input_action_cat': // Category
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = ec_selected_cat;
        document.getElementById('ec_in_up_imgs_id').value = '';
        /* ec_selected_user = (ec_selected_user == 'ec_sel_user_none') ?
         'ec_sel_user_old' : ec_selected_user; */
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
      case 'ec_input_action_img': // Image
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = ec_selected_cat;
        document.getElementById('ec_in_up_imgs_id').value = ec_selected_img;
        /* ec_selected_user = (ec_selected_user == 'ec_sel_user_none') ?
         'ec_sel_user_old' : ec_selected_user; */
        ec_check_img_text();
      break;
      case 'ec_input_action_home': // Home
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = '-1';
        document.getElementById('ec_in_up_imgs_id').value = '';
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
    }
    if (ec_avoid_infinite_loop) {
      ec_avoid_infinite_loop = false;
      ec_mark_user(ec_selected_user);
      ec_avoid_infinite_loop = true;
    }
  }
}

function ec_rnd(ec_min, ec_max) {
  return Math.floor(ec_min + (ec_max - ec_min + 1) * Math.random() );
}

function ec_gen_txt(ec_length) {
  var t = '';
  var ec_reg_A = /[A-Z]+/;
  var ec_reg_a = /[a-z]+/;
  var ec_reg_0 = /[0-9]+/;
  var i = 0;
  var ec_l = 0;
  ec_l = parseInt(ec_length);
  if (ec_l < 3) {
    ec_err = '< 3';
    return '';
  }
  do {
    i++;
    switch (ec_rnd(0, 2)) {
      case 0: // A - Z
        t += String.fromCharCode(ec_rnd(65, 90));
      break;
      case 1: // a - z
        t += String.fromCharCode(ec_rnd(97, 122));
      break;
      case 2: // 0 - 9
        t += String.fromCharCode(ec_rnd(48, 57));
      break;
    }
    if (i > 500) {
      break;
    }
    if ((t.length) > (ec_l)) {
      t = t.substr(1, ec_l);
    }
  } while (
   (t.length < ec_l) ||
   !( ec_reg_A.test(t) && ec_reg_a.test(t) && ec_reg_0.test(t) )
  );
  if (i > 500) {
    ec_err = '> 500\n' + t;
    return '';
  }
  else {
    return t;
  }
}

function ec_gen_code() {
  var t = '';
  t = ec_gen_txt(ec_auto_code_digits_nb);
  if (t == '') {
    alert("Failed :\n" + ec_err);
    ec_new_code_text = 'Failed...';
  }
  else {
    ec_new_code_text = t;
  }
  document.getElementById('ec_in_up_code_id').value = ec_new_code_text;
}

function ec_gen_user() {
  var t           = '';
  var ec_word     = '';
  var ec_cat_sel  = '';
  var ec_reg_cat2 = /\//;
  var ec_reg_ap   = /^\S+/;
  var ec_reg_cat1 = /\/\s(.+)$/;
  if (
   ec_selected_action == '' ||
   (ec_selected_action == 'ec_input_action_cat' && ec_selected_cat == '-1') ||
   (ec_selected_action == 'ec_input_action_img' &&
    (ec_selected_img == '' || ec_selected_cat == '-1')) ||
   (ec_selected_action == 'ec_input_action_add_p' && ec_selected_AP == '-1')
  ) {
    alert(ec_JS_message['ec_gen_user_act_miss']);
    return false;
  }
  else {
    t = ec_gen_txt('8');
    if (t == '') {
      alert("Failed :\n" + ec_err);
      ec_new_psd_text = 'Failed...';
      return false;
    }
    else {
      ec_new_psd_text = t;
      ec_old_new_psd_text = ec_new_psd_text;
    }
    switch (ec_selected_action) {
      case 'ec_input_action_add_p': // Additional Page
        ec_new_user_text = ec_reg_ap.exec(
         document.ec_new_code.ec_in_up_aps.options[
          document.ec_new_code.ec_in_up_aps.selectedIndex
         ].label
        );
      break;
      case 'ec_input_action_cat': // Category
      case 'ec_input_action_img': // Image
        ec_cat_sel = document.ec_new_code.ec_in_up_cat.options[
          document.ec_new_code.ec_in_up_cat.selectedIndex
         ].label;
        ec_new_user_text = (ec_reg_cat2.test(ec_cat_sel)) ?
         ec_reg_cat1.exec(ec_cat_sel)[1] : ec_cat_sel;
      if (ec_selected_action == 'ec_input_action_img') {
        ec_new_user_text +=  '_' + document.ec_new_code.ec_in_up_imgs_id.value;
      }
      break;
      case 'ec_input_action_home': // Home
        t = ec_gen_txt('3');
        if (t == '') {
          alert("Failed :\n" + ec_err);
          ec_new_psd_text = 'Failed...';
          return false;
        }
        ec_new_user_text = ec_JS_message['ec_up_code_lbl_home'] + '_' + t;
      break;
    }
    ec_mark_user('ec_sel_user_new');
    return true;
  }
}

function ec_gen_full_auto() {
  if (ec_gen_user()) ec_gen_code();
}

function ec_check_img_text() {
  document.getElementById('ec_in_up_imgs_warn').innerHTML = (
   document.getElementById('ec_in_up_imgs_id').value != '' &&
   document.getElementById('ec_in_up_cats_id').value == '-1'
  ) ? ec_JS_message['ec_act_cat_miss'] : '';
}

function ec_check_pwd_text() {
  document.getElementById('ec_in_up_pwd_warn').innerHTML = (
   document.getElementById('ec_in_up_psd_txt_id').value == ec_old_new_psd_text
   && ec_old_new_psd_text != ''
   && ec_selected_user == 'ec_sel_user_new'
  ) ? ec_JS_message['ec_new_pwd_gen'] : '';
}

function ec_check_submit() {
  if (document.getElementById('ec_in_up_code_id').value == '') {
    alert(ec_JS_message['ec_submit_code_miss']);
    return false;
  }
  if ((
    document.getElementById('ec_sel_user_new').checked != '' &&
    document.getElementById('ec_in_up_usr_txt_id').value == ''
    ) || (
    document.getElementById('ec_sel_user_old').checked != '' &&
    document.ec_new_code.ec_in_up_usr_list.value == '-1'
    ) || (
    document.getElementById('ec_sel_user_new').checked == '' &&
    document.getElementById('ec_sel_user_old').checked == ''
    )
  ) {
    alert(ec_JS_message['ec_submit_user_miss']);
    return false;
  }
}

function ec_test() {
  alert('OK.');
}

function ec_init() {
  ec_err = '';
  ec_selected_user = 'ec_sel_user_old';
  ec_selected_old_user = '-1';
  ec_selected_AP = '-1';
  ec_selected_cat = '-1';
  ec_selected_action = '';
  ec_selected_img = '';
  ec_new_code_text = '';
  ec_new_user_text = '';
  ec_new_psd_text = '';
  ec_old_new_psd_text = '';
  ec_test_reg = '';
  document.getElementById('ec_act1_id').value = 'create';
  document.getElementById('ec_in_up_pwd_warn').innerHTML = '';
  document.getElementById('ec_sel_user_new').checked = 'checked';
  document.getElementById('ec_sel_user_new').checked = '';
  document.getElementById('ec_input_action_home').checked = 'checked';
  document.getElementById('ec_input_action_home').checked = '';
  document.getElementById('ec_in_up_usr_txt_id').value = '';
  document.getElementById('ec_in_up_psd_txt_id').value = '';
  document.getElementById('ec_in_up_usr_list_id').value = '-1';
  document.getElementById('ec_in_up_code_id').value = '';
  document.getElementById('ec_in_up_aps_id').value = '-1';
  document.getElementById('ec_in_up_cats_id').value = '-1';
  document.getElementById('ec_in_up_imgs_id').value = '';
}
